#                                               18 December 2020.  SMS.
#
#    Wget 1.20.3 for VMS - MMS (or MMK) Common Source Description File.
#

# This description file is included by other description files.  It is
# not intended to be used alone.  Verify proper inclusion.

.IFDEF INCL_DESCRIP_SRC
.ELSE
$$$$ THIS DESCRIPTION FILE IS NOT INTENDED TO BE USED THIS WAY.
.ENDIF # INCL_DESCRIP_SRC


# Define MMK architecture macros when using MMS.

.IFDEF __MMK__                  # __MMK__
.ELSE                           # __MMK__
ALPHA_X_ALPHA = 1
IA64_X_IA64 = 1
VAX_X_VAX = 1
.IFDEF $(MMS$ARCH_NAME)_X_ALPHA     # $(MMS$ARCH_NAME)_X_ALPHA
__ALPHA__ = 1
.ENDIF                              # $(MMS$ARCH_NAME)_X_ALPHA
.IFDEF $(MMS$ARCH_NAME)_X_IA64      # $(MMS$ARCH_NAME)_X_IA64
__IA64__ = 1
.ENDIF                              # $(MMS$ARCH_NAME)_X_IA64
.IFDEF $(MMS$ARCH_NAME)_X_VAX       # $(MMS$ARCH_NAME)_X_VAX
__VAX__ = 1
.ENDIF                              # $(MMS$ARCH_NAME)_X_VAX
.ENDIF                          # __MMK__ [else]

# Analyze architecture-related and option macros.

.IFDEF __ALPHA__                # __ALPHA__
DESTM = ALPHA
.ELSE                           # __ALPHA__
.IFDEF __IA64__                     # __IA64__
DESTM = IA64
.ELSE                               # __IA64__
.IFDEF __VAX__                          # __VAX__
DESTM = VAX
.ELSE                                   # __VAX__
DESTM = UNK
UNK_DEST = 1
.ENDIF                                  # __VAX__ [else]
.ENDIF                              # __IA64__ [else]
.ENDIF                          # __ALPHA__ [else]

# Large-file support.  Always no on VAX.  Assume yes elsewhere.  On
# Alpha, the .FIRST rule will detect incompatibility (before VMS V7.2).

# Targets which can bypass the (slow) large-file test (on Alpha).
# (Not "" or ALL.)

TRGT_CLEAN = 1
TRGT_CLEAN_ALL = 1
TRGT_CLEAN_EXE = 1
TRGT_CLEAN_OLB = 1
TRGT_DASHV = 1
TRGT_HELP = 1

TRGT = TRGT_$(MMSTARGETS)

.IFDEF $(TRGT)                  # $(TRGT)
.IFDEF __ALPHA__                    # __ALPHA__
.IFDEF NOCHECK_LARGE                    # NOCHECK_LARGE
.ELSE                                   # NOCHECK_LARGE
NOCHECK_LARGE = 1
.ENDIF                                  # NOCHECK_LARGE [else]
.ENDIF                              # __ALPHA__
.ENDIF                          # $(TRGT)

.IFDEF __VAX__                  # __VAX__
.IFDEF LARGE                        # LARGE
LARGE_VAX = 1
.ENDIF                              # LARGE
.IFDEF NOLARGE                      # NOLARGE
.ELSE                               # NOLARGE
NOLARGE = 1
.ENDIF                              # NOLARGE [else]
.ENDIF                          # __VAX__

# Translate NO_LARGE to NOLARGE.
.IFDEF NO_LARGE                 # NO_LARGE
.IFDEF NOLARGE                      # NOLARGE
.ELSE                               # NOLARGE
NOLARGE = 1
.ENDIF                              # NOLARGE [else]
.ENDIF                          # NO_LARGE

.IFDEF NOLARGE                  # NOLARGE
.ELSE                           # NOLARGE
.IFDEF LARGE                        # LARGE
.ELSE                               # LARGE
LARGE = 1
.IFDEF __ALPHA__                        # __ALPHA__
.IFDEF NOCHECK_LARGE                        # NOCHECK_LARGE
.ELSE                                       # NOCHECK_LARGE
CHECK_LARGE = 1
.ENDIF                                      # NOCHECK_LARGE [else]
.ENDIF                                  # __ALPHA__ [else]
.ENDIF                              # LARGE [else]
DESTL = L
.ENDIF                          # NOLARGE [else]

DEST = $(DESTM)$(DESTL)

# DASHD options.

# Translate NO_DASHD to NODASHD.
.IFDEF NO_DASHD                 # NO_DASHD
.IFDEF NODASHD                      # NODASHD
.ELSE                               # NODASHD
NODASHD = 1
.ENDIF                              # NODASHD [else]
.ENDIF                          # NO_DASHD

.IFDEF NODASHD                  # NODASHD
CDEFS_DASHD =
.ELSE                           # NODASHD
CDEFS_DASHD = , "ENABLE_DEBUG"
.ENDIF                          # NODASHD [else]

# DBG options.

.IFDEF DBG                      # DBG
CFLAGS_DBG = /debug /nooptimize
LINKFLAGS_DBG = /debug /traceback
.ELSE                           # DBG
CFLAGS_DBG =
.IFDEF TRC                          # TRC
LINKFLAGS_DBG = /traceback
.ELSE                               # TRC
LINKFLAGS_DBG = /notraceback
.ENDIF                              # TRC
.ENDIF                          # DBG [else]

# Large-file options.

.IFDEF LARGE                    # LARGE
CDEFS_LARGE = , "_LARGEFILE"
.ELSE                           # LARGE
CDEFS_LARGE =
.ENDIF                          # LARGE [else]

# SSL options.

.IFDEF HPSSL                    # HPSSL
.IFDEF HPSSL1                       # HPSSL1
.IFDEF MULTI_SSL                        # MULTI_SSL
.ELSE                                   # MULTI_SSL
MULTI_SSL = HPSSL HPSSL1
.ENDIF                                  # MULTI_SSL [else]
.ENDIF                              # HPSSL1
.IFDEF OSSL                         # OSSL
.IFDEF MULTI_SSL                        # MULTI_SSL
.ELSE                                   # MULTI_SSL
MULTI_SSL = HPSSL OSSL
.ENDIF                                  # MULTI_SSL [else]
.ENDIF                              # OSSL
.IFDEF OSSLD                        # OSSLD
.IFDEF MULTI_SSL                        # MULTI_SSL
.ELSE                                   # MULTI_SSL
MULTI_SSL = HPSSL OSSLD
.ENDIF                                  # MULTI_SSL [else]
.ENDIF                              # OSSLD
.IFDEF MULTI_SSL                    # MULTI_SSL
.ELSE                               # MULTI_SSL
# HPSSL.
CDEFS_SSL = , "HAVE_LIBSSL", "ENABLE_NTLM"
SSL_INCL = SSL$INCLUDE
SSL_LINK_OPT = , [-.VMS]WGET_SSL_HP.OPT /OPTIONS
.ENDIF                              # MULTI_SSL [else]
.ELSE                           # HPSSL
.IFDEF HPSSL1                       # HPSSL1
.IFDEF OSSL                             # OSSL
.IFDEF MULTI_SSL                            # MULTI_SSL
.ELSE                                       # MULTI_SSL
MULTI_SSL = HPSSL1 OSSL
.ENDIF                                      # MULTI_SSL [else]
.ENDIF                                  # OSSL
.IFDEF OSSLD                            # OSSLD
.IFDEF MULTI_SSL                            # MULTI_SSL
.ELSE                                       # MULTI_SSL
MULTI_SSL = HPSSL1 OSSLD
.ENDIF                                      # MULTI_SSL [else]
.ENDIF                                  # OSSLD
.IFDEF MULTI_SSL                        # MULTI_SSL
.ELSE                                   # MULTI_SSL
# HPSSL1.
CDEFS_SSL = , "HAVE_LIBSSL", "ENABLE_NTLM"
SSL_INCL = SSL1$INCLUDE
SSL_LINK_OPT = , [-.VMS]WGET_SSL_HP1.OPT /OPTIONS
.ENDIF                                  # MULTI_SSL [else]
.ELSE                               # HPSSL1
.IFDEF OSSL                             # OSSL
.IFDEF OSSLD                                # OSSLD
.IFDEF MULTI_SSL                                # MULTI_SSL
.ELSE                                           # MULTI_SSL
MULTI_SSL = OSSL OSSLD
.ENDIF                                          # MULTI_SSL [else]
.IFDEF MULTI_SSL                                # MULTI_SSL
.ELSE                                           # MULTI_SSL
# OSSL.
CDEFS_SSL = , "HAVE_LIBSSL", "ENABLE_NTLM"
SSL_INCL = SSLINCLUDE
# SSL_LINK_OPT DCL symbol will be defined in the .FIRST actions.
.ENDIF                                          # MULTI_SSL [else]
.ENDIF                                      # OSSLD
.ELSE                                   # OSSL
.IFDEF OSSLD                                # OSSLD
.IFDEF MULTI_SSL                                # MULTI_SSL
.ELSE                                           # MULTI_SSL
# OSSLD.
CDEFS_SSL = , "HAVE_LIBSSL", "ENABLE_NTLM"
SSL_INCL = OSSL$INCLUDE:[openssl]
.IFDEF OSSLOLB                                      # OSSLOLB
SSL_LINK_OPT = , [-.VMS]WGET_SSL_OD_OLB.OPT /OPTIONS
.ELSE                                               # OSSLOLB
SSL_LINK_OPT = , [-.VMS]WGET_SSL_OD_SHR.OPT /OPTIONS
.ENDIF                                              # OSSLOLB [else]
.ENDIF                                          # MULTI_SSL [else]
.ELSE                                       # OSSLD
CDEFS_SSL =
SSL_LINK_OPT =
.ENDIF                                      # OSSLD [else]
.ENDIF                                  # OSSL [else]
.ENDIF                              # HPSSL1 [else]
.ENDIF                          # HPSSL [else]

# ZLIB options.

.IFDEF WGET_ZLIB                # WGET_ZLIB
CDEFS_ZLIB = , "HAVE_LIBZ"
.ELSE                           # WGET_ZLIB
CDEFS_ZLIB =
.ENDIF                          # WGET_ZLIB [else]

# User-specified options.

.IFDEF CDEFS_USER               # CDEFS_USER
CDEFS_USR = , $(CDEFS_USER)
.ELSE                           # CDEFS_USER
CDEFS_USR =
.ENDIF                          # CDEFS_USER [else]


# Specific DESCRIP_SRC.MMS defines:
#    CDEFS
#    CFLAGS_SPEC
#    CFLAGS_INCL

CDEFS_CMN = VMS, HAVE_CONFIG_H, _POSIX_EXIT, OS_TYPE="$(OS_TYPE)" \
 $(CDEFS_DASHD) $(CDEFS_LARGE) $(CDEFS_SSL) $(CDEFS_USR) $(CDEFS_ZLIB)


# Absence of MMSDESCRIPTION_FILE.
.IFDEF MMSDESCRIPTION_FILE      # MMSDESCRIPTION_FILE
.ELSE                           # MMSDESCRIPTION_FILE
NO_MMSDESCRIPTION_FILE = 1
.ENDIF                          # MMSDESCRIPTION_FILE [else]


# Subsidiary directory names.  (Note: DEST must be defined first.)

DIR_LIB = LIB
DIR_LIB_DEST = [-.$(DIR_LIB).$(DEST)]
DIR_LIB_DEST_FILE = [-.$(DIR_LIB)]$(DEST).DIR;1

DIR_SRC = SRC
DIR_SRC_DEST = [-.$(DIR_SRC).$(DEST)]
DIR_SRC_DEST_FILE = [-.$(DIR_SRC)]$(DEST).DIR;1

DIR_VMS = VMS

# Object library names.

LIB_LIB = $(DIR_LIB_DEST)LIBLIB.OLB
LIB_SRC = $(DIR_SRC_DEST)LIBSRC.OLB

# DECC_VER object name.

DECC_VER_OBJ = $(DIR_SRC_DEST)DECC_VER.OBJ

# Executable names.

WGET_EXE = $(DIR_SRC_DEST)WGET.EXE
DECC_VER_EXE = $(DIR_SRC_DEST)DECC_VER.EXE

EXES = $(WGET_EXE) \
       $(DECC_VER_EXE)

# Help file names.

WGET_HLB = [-.$(DIR_VMS)]WGET.HLB
WGET_HLP = [-.$(DIR_VMS)]WGET.HLP


# Complain if warranted.  Otherwise, show destination directory.
# Make the destination directory, if necessary.
# Define logical name "sys" to deal with "#include <sys/XXX.h>".
				
.IFDEF UNK_DEST                 # UNK_DEST
.FIRST
	@ write sys$output -
 "   Unknown system architecture."
.IFDEF __MMK__                      # __MMK__
	@ write sys$output -
 "   MMK on IA64?  Try adding ""/MACRO = __IA64__""."
.ELSE                               # __MMK__
	@ write sys$output -
 "   MMS too old?  Try adding ""/MACRO = MMS$ARCH_NAME=ALPHA"","
	@ write sys$output -
 "   or ""/MACRO = MMS$ARCH_NAME=IA64"", or ""/MACRO = MMS$ARCH_NAME=VAX"","
	@ write sys$output -
 "   as appropriate.  (Or try a newer version of MMS.)"
.ENDIF                              # __MMK__ [else]
	@ write sys$output ""
	I_WILL_DIE_NOW.  /$$$$INVALID$$$$
.ELSE                           # UNK_DEST
.IFDEF LARGE_VAX                    # LARGE_VAX
.FIRST
	@ write sys$output -
 "   Macro ""LARGE"" is invalid on VAX."
	@ write sys$output ""
	I_WILL_DIE_NOW.  /$$$$INVALID$$$$
.ELSE                               # LARGE_VAX
.IFDEF MULTI_SSL                        # MULTI_SSL
.FIRST
	@ write sys$output -
 "   Multiple SSL macros defined: $(MULTI_SSL)."
	@ write sys$output ""
	I_WILL_DIE_NOW.  /$$$$INVALID$$$$
.ELSE                                   # MULTI_SSL
.IFDEF NO_MMSDESCRIPTION_FILE               # NO_MMSDESCRIPTION_FILE
.FIRST
	@ write sys$output -
 "   Macro ""MMSDESCRIPTION_FILE"" is not defined as required."
	@ write sys$output -
 "   MMK, or MMS too old?  Try adding:"
	@ write sys$output -
 "   ""/MACRO = MMSDESCRIPTION_FILE=dev:[dir]description_file"","
	@ write sys$output -
 "   as appropriate, where ""dev:[dir]description_file"" is the full path"
	@ write sys$output -
 "   to the MMS/MMK description file being used (typically ""DESCRIP.MMS"")."
	@ write sys$output ""
	I_WILL_DIE_NOW.  /$$$$INVALID$$$$
.ELSE                                       # NO_MMSDESCRIPTION_FILE
.FIRST
	@ show time
	@ write sys$output "   Destination: [.$(DEST)]"
	@ write sys$output ""
.IFDEF SSL_INCL                                 # SSL_INCL
	@ ! SSL include logical name.
	@ write sys$output "   OPENSSL: $(SSL_INCL)"
	@ define /nolog openssl $(SSL_INCL)
	@ write sys$output ""
.ENDIF                                          # SSL_INCL
	@ ! Create DCL symbol (close enough to MMS macro) for OS_TYPE.
	@ if (f$getsyi( "hw_model") .lt. 1024) then arch_name = "VAX"
	@ if (f$getsyi( "hw_model") .ge. 1024) then -
	   arch_name = f$getsyi( "arch_name")
	@ OS_TYPE = """""VMS "+ arch_name+ " "+ -
	   f$edit( f$getsyi( "version"), "trim")+ """"""
	@ write sys$output "   OS_TYPE string: ''OS_TYPE'"
	@ write sys$output ""
.IFDEF WGET_ZLIB                                # WGET_ZLIB
	@ if (f$trnlnm( "lib_zlib", "LNM$PROCESS") .eqs. "") then -
	   @[-.VMS]FIND_LIB.COM $(WGET_ZLIB) $(DESTM) LIBZ.OLB lib_zlib
	@ if (f$trnlnm( "lib_zlib") .eqs. "") then -
	   write sys$output "   Can not find ZLIB object library."
	@ if (f$trnlnm( "lib_zlib") .eqs. "") then -
	   write sys$output ""
	@ if (f$trnlnm( "lib_zlib") .eqs. "") then -
	   I_WILL_DIE_NOW.  /$$$$INVALID$$$$
	@ write sys$output "   ZLIB dir:  ''f$trnlnm( "lib_zlib")'"
	@ write sys$output ""
	@ if (f$trnlnm( "incl_zlib", "LNM$PROCESS") .eqs. "") then -
	   define /log incl_zlib $(WGET_ZLIB)
.ENDIF                                          # WGET_ZLIB
.IFDEF CHECK_LARGE                              # CHECK_LARGE
	@ write sys$output ""
	@ write sys$output "   Verifying large-file support..."
	@ if (f$search( "$(DEST).DIR;1", 1) .eqs. "") then -
	 create /directory [.$(DEST)]
	@ @[-.VMS]CHECK_LARGE.COM $(DEST) large_ok
	@ if (f$search( "[.$(DEST)]*.*", 2) .eqs. "") then -
	   set protection = w:d $(DEST).DIR;1
	@ if (f$search( "[.$(DEST)]*.*", 3) .eqs. "") then -
	   delete $(DEST).DIR;1
	@ no_large_dcl_sym = (f$trnlnm( "large_ok") .eqs. "")
	@ if (no_large_dcl_sym) then -
	   write sys$output -
	    "   Large-file support not available with this VMS/CRTL version."
	@ if (no_large_dcl_sym) then -
	   write sys$output "   Add ""/MACRO = NOLARGE=1""."
	@ if (no_large_dcl_sym) then -
	   I_WILL_DIE_NOW.  /$$$$INVALID$$$$
	@ write sys$output "   Large-file support ok."
	@ write sys$output ""
.ENDIF                                          # CHECK_LARGE
	@ ! Define the OpenSSL LINK option DCL symbol (close enough to
	@ ! MMS macro) according to which shared image or object library
	@ ! is available in "SSLLIB:".  Two OpenSSL naming conventions
	@ ! are supported -- Old: LIBSSL.EXE/LIBSSL.OLB; New (HP-like):
	@ ! SSL_LIBSSL_SHR32.EXE/SSL_LIBSSL32.OLB.  Each has its own
	@ ! LINK options files.  Look first for the newer names.  If not
	@ ! found, then fall back to the older names.
	@ ! Prefer .EXE to .OLB, unless OSSLOLB is defined.
.IFDEF OSSL                                     # OSSL
	@ ! Define DCL symbol SSL_LINK_OPT.
	@ SSL_LINK_OPT = ""
.IFDEF OSSLOLB                                      # OSSLOLB
.ELSE                                               # OSSLOLB
	@ ! Allow .EXE or .OLB.  Look first for newer "SSL_" .EXE.
	@ if (f$search( "SSLLIB:SSL_LIBSSL_SHR32.EXE") .nes. "") then -
	   SSL_LINK_OPT = ", [-.VMS]WGET_SSL_O_SHR_SSL.OPT /OPTIONS"
	@ ! Look next for older no-"SSL_" .EXE.
	@ if ((SSL_LINK_OPT .eqs. "") .and. -
	   (f$search( "SSLLIB:LIBSSL.EXE") .nes. "")) then -
	   SSL_LINK_OPT = ", [-.VMS]WGET_SSL_O_SHR.OPT /OPTIONS"
	@ ! If no .EXE, look for newer "SSL_" .OLB.
.ENDIF                                              # OSSLOLB [else]
	@ ! Allow .OLB only, or no .EXE found.  Look for newer "SSL_" .OLB.
	@ if ((SSL_LINK_OPT .eqs. "") .and. -
	   (f$search( "SSLLIB:SSL_LIBSSL32.OLB") .nes. "")) then -
	   SSL_LINK_OPT = ", [-.VMS]WGET_SSL_O_OLB_SSL.OPT /OPTIONS"
	@ ! Last choice is older no-"SSL_" .OLB.
	@ if ((SSL_LINK_OPT .eqs. "") .and. -
	   (f$search( "SSLLIB:LIBSSL.OLB") .nes. "")) then -
	   SSL_LINK_OPT = ", [-.VMS]WGET_SSL_O_OLB.OPT /OPTIONS"
	@ if (SSL_LINK_OPT .eqs. "") then -
	   write sys$output -
 "   Can not find any OpenSSL object library (.OLB) or shared image (.EXE)."
	@ if (SSL_LINK_OPT .eqs. "") then -
	   write sys$output ""
	@ if (SSL_LINK_OPT .eqs. "") then -
	   I_WILL_DIE_NOW.  /$$$$INVALID$$$$
.ENDIF                                          # OSSL

.IFDEF OSSLD                                    # OSSLD
.ENDIF                                          # OSSLD


	@ ! Create this specific destination directory first.
.IFDEF CREATE_DESTINATION                       # CREATE_DESTINATION
	if (f$search( "$(DEST).DIR;1") .eqs. "") then -
	 create /directory [.$(DEST)]
.ENDIF                                          # CREATE_DESTINATION
	define sys 'f$parse( "$(MMSDESCRIPTION_FILE)", , , "DIRECTORY")'
.ENDIF                                      # NO_MMSDESCRIPTION_FILE [else]
.ENDIF                                  # MULTI_SSL [else]
.ENDIF                              # LARGE_VAX [else]
.ENDIF                          # UNK_DEST [else]

# UTIME prefix quirk.

.IFDEF __VAX__
.ELSE
UTNP = , __UTC_UTIME
.ENDIF

# Architecture-specific CC and LINK flags.

.IFDEF __VAX__                  # __VAX__
CFLAGS_ARCH = /decc
.ELSE                           # __VAX__
CFLAGS_ARCH = /float = ieee_float
.ENDIF                          # __VAX__ [else]

LFLAGS_ARCH =

# LIST options.

.IFDEF LIST                     # LIST
# Note: Before DEC C V6.0, "/show = [no]messages" will cause trouble.
CFLAGS_LIST = /list = $*.LIS /show = (all, nomessages)
LINKFLAGS_LIST = /map = $*.MAP /cross_reference /full
.ELSE                           # LIST
CFLAGS_LIST =
LINKFLAGS_LIST =
.ENDIF                          # LIST [else]

# ZLIB options.

.IFDEF WGET_ZLIB                # WGET_ZLIB
ZLIB_LINK_OPT = , LIB_ZLIB:LIBZ.OLB /library
.ENDIF                          # WGET_ZLIB

